/*
 * Copyright (c) 2002 Sandro Sigala.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef MAPVIEWER_H
#define MAPVIEWER_H

#include <fx.h>

#include "fxreptoned.h"

class Map;
class Transporter;

class MapViewer: public FXScrollArea {
    	FXDECLARE(MapViewer)

private:
	Map *map;
	FXBMPImage **sprites;
	Sprite currenttool;
	bool leftbtn;

	void mouseClickEvent(int x, int y);

protected:
	MapViewer();
 	virtual void layout();

private:
  	MapViewer(const MapViewer&);
  	MapViewer& operator =(const MapViewer&);

public:
  	long onPaint		(FXObject *, FXSelector, void *);
	long onMotion		(FXObject *, FXSelector, void *);
	long onLeftBtnPress	(FXObject *, FXSelector, void *);
  	long onLeftBtnRelease	(FXObject *, FXSelector, void *);

public:
  	MapViewer(FXComposite *p, FXObject *tgt, FXSelector sel, FXuint opts, FXint x=0, FXint y=0, FXint w=0, FXint h=0);
	~MapViewer();

	virtual void create();

	virtual FXbool canFocus() const;

	virtual FXint getContentWidth();
  	virtual FXint getContentHeight();

	void setMap(Map *m, FXBMPImage **s);
	void setTool(Sprite tool);

	static bool getTransCoordinates(FXWindow *owner, Map *m, Transporter *t, bool change);
};

#endif // MAPVIEWER_H
